/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package doca;

import static doca.Doca.connexionDB;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.text.SimpleDateFormat;
import java.util.Date;
import javax.swing.JOptionPane;

/**
 *
 * @author Manox-1
 */
public class rechercheNote extends javax.swing.JDialog {

    private Note myconnexion;

    

    /**
     * Creates new form rechercheNote
     */
    public rechercheNote() {
        
        initComponents();
    }
    
    /**
     *
     * @param c
     */
    public rechercheNote(Note c) {
        
        this.myconnexion= c;
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        note = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        recherche = new javax.swing.JButton();
        date = new com.toedter.calendar.JDateChooser();
        jScrollPane1 = new javax.swing.JScrollPane();
        resultat = new javax.swing.JTextArea();
        complete = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        Cancel = new javax.swing.JButton();
        cancel = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jPanel1.setBackground(new java.awt.Color(255, 77, 100));

        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/doca.jpg"))); // NOI18N
        jLabel1.setText("jLabel1");
        jLabel1.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));

        note.setFont(new java.awt.Font("Tahoma", 3, 14)); // NOI18N
        note.setBorder(new javax.swing.border.MatteBorder(null));

        jLabel2.setFont(new java.awt.Font("Tahoma", 3, 14)); // NOI18N
        jLabel2.setText("Rechercher vos notes :");

        recherche.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        recherche.setText("Rechercher");
        recherche.setBorder(new javax.swing.border.MatteBorder(null));
        recherche.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rechercheActionPerformed(evt);
            }
        });

        date.setBorder(new javax.swing.border.MatteBorder(null));
        date.setFont(new java.awt.Font("Tahoma", 3, 14)); // NOI18N

        resultat.setColumns(20);
        resultat.setFont(new java.awt.Font("Monospaced", 3, 14)); // NOI18N
        resultat.setRows(5);
        resultat.setTabSize(5);
        resultat.setBorder(new javax.swing.border.MatteBorder(null));
        jScrollPane1.setViewportView(resultat);

        complete.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        complete.setText("Notes complete");
        complete.setBorder(new javax.swing.border.MatteBorder(null));
        complete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                completeActionPerformed(evt);
            }
        });

        jLabel3.setFont(new java.awt.Font("Tahoma", 3, 12)); // NOI18N
        jLabel3.setText("Note :");
        jLabel3.setBorder(new javax.swing.border.MatteBorder(null));

        jLabel4.setFont(new java.awt.Font("Tahoma", 3, 12)); // NOI18N
        jLabel4.setText("Date :");
        jLabel4.setBorder(new javax.swing.border.MatteBorder(null));

        Cancel.setText("Retour");
        Cancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CancelActionPerformed(evt);
            }
        });

        cancel.setText("EXIT");
        cancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 500, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(37, 37, 37)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(jLabel4, javax.swing.GroupLayout.DEFAULT_SIZE, 60, Short.MAX_VALUE)
                                    .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(date, javax.swing.GroupLayout.DEFAULT_SIZE, 370, Short.MAX_VALUE)
                                    .addComponent(note)))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(recherche, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(240, 240, 240)
                                        .addComponent(complete, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 450, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGroup(jPanel1Layout.createSequentialGroup()
                                            .addGap(145, 145, 145)
                                            .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 200, javax.swing.GroupLayout.PREFERRED_SIZE))))
                                .addGap(0, 4, Short.MAX_VALUE)))
                        .addContainerGap())
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(Cancel)
                        .addGap(45, 45, 45)
                        .addComponent(cancel)
                        .addGap(156, 156, 156))))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(106, 106, 106)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 504, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addGap(18, 18, 18)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(note, javax.swing.GroupLayout.PREFERRED_SIZE, 35, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 35, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(date, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 290, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(recherche, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(complete, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(Cancel)
                            .addComponent(cancel))))
                .addContainerGap(70, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * A partir de ce bouton, on pourra rechercher une note en fonction de la date ou la note de l'utilisateur.
     */
    private void rechercheActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rechercheActionPerformed
        
        System.out.println(myconnexion.getConnection());
        // recuperer les valeur ecrite par l'utilisateur
        String text = note.getText();
        resultat.setText("");
        //si le text est vide alors voir le champ pour la date
        if (text.isEmpty()){
            System.out.println("date test");
            try {
                Date madate = date.getDate();
                String ladate = new SimpleDateFormat("yyyy-MM-dd").format(madate);
                ResultSet rs ;
                PreparedStatement ps ;
                String requete;
                String ancien ;
                String nouveau= "" ;
                Connection cnx = connexionDB();
                /*requete = "SELECT * FROM notes WHERE date = '"+ladate+"' and util_id = (SELECT id FROM users WHERE username = '"+myconnexion.getConnection()+"')";        
                ps = cnx.prepareStatement(requete);
                rs = ps.executeQuery();*/
                System.out.println(ladate);
                
            String sql = "SELECT * FROM notes WHERE date = ? and util_id = (SELECT id FROM users WHERE username = ?)";
            PreparedStatement pst = cnx.prepareStatement(sql);
            pst.setString(1,ladate);
            pst.setString(2,myconnexion.getConnection());
            rs = pst.executeQuery();
                while (rs.next()){
                    System.out.println(rs.getString("date"));
                    ancien = rs.getDate("date")+" : "+rs.getString("info") ;
                    nouveau = nouveau +System.getProperty("line.separator")+ ancien;
                    
                }
                resultat.setText(System.getProperty("line.separator")+nouveau);
                
                    }catch(Exception e){
                        System.out.println("Erreur requete");
                    }
        }else{
            try {
                ResultSet rs ;
                PreparedStatement ps ;
                String requete;
                String ancien ;
                String nouveau= "" ;
                Connection cnx = connexionDB();
                /*requete = "SELECT * FROM notes WHERE info LIKE '%"+text+"%' and util_id = (SELECT id FROM users WHERE username = '"+myconnexion.getConnection()+"')";        
                ps = cnx.prepareStatement(requete);
                rs = ps.executeQuery();*/
                
            String sql = "SELECT * FROM notes WHERE info = ?  and util_id = (SELECT id FROM users WHERE username = ?)";
            PreparedStatement pst = cnx.prepareStatement(sql);
            pst.setString(1,text);
            pst.setString(2,myconnexion.getConnection());
            System.out.println(pst.executeQuery());
            rs = pst.executeQuery();
                
            
                
                while (rs.next()){
                    System.out.println(rs.getString("date"));
                    ancien = rs.getDate("date")+" : "+rs.getString("info") ;
                    nouveau = nouveau +System.getProperty("line.separator")+ ancien;
                }
                resultat.setText(System.getProperty("line.separator")+nouveau);
                    }catch(Exception e){
                        System.out.println("Erreur requete");
                    }
        }
    }//GEN-LAST:event_rechercheActionPerformed

    /**
     * Et ce bouton affichera toutes les notes de l'utilisateur
     */
    private void completeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_completeActionPerformed
        resultat.setText("");
        try {
            ResultSet rs ;
            PreparedStatement ps ;
            String requete;
            
            String ancien ;
            String nouveau= "" ;
            Connection cnx = connexionDB();
            /*requete = "select * from notes where util_id = (SELECT id FROM users WHERE username = '"+myconnexion.getConnection()+"') ";        
            ps = cnx.prepareStatement(requete);
            rs = ps.executeQuery();*/
            String sql = "SELECT * FROM notes WHERE util_id = (SELECT id FROM users WHERE username = ?)";
            PreparedStatement pst = cnx.prepareStatement(sql);
            pst.setString(1,myconnexion.getConnection());
            rs = pst.executeQuery();
            while (rs.next()){
                System.out.println(rs.getString("date"));
                ancien = rs.getDate("date")+" : "+rs.getString("info") ;
                nouveau = nouveau +System.getProperty("line.separator")+ ancien;
            }
            resultat.setText(System.getProperty("line.separator")+nouveau);
                }catch(Exception e){
                    System.out.println("Erreur requete");
                }
      
    }//GEN-LAST:event_completeActionPerformed

    /**
     * Cette parti sert à se deplacer vers une autre page
     */
    private void CancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CancelActionPerformed
        
         Note notes = new Note();
                    setVisible(false);
                    notes.setVisible(true);
                    
                    
    }//GEN-LAST:event_CancelActionPerformed

    private void cancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelActionPerformed
System.exit(0);        
    }//GEN-LAST:event_cancelActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(rechercheNote.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(rechercheNote.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(rechercheNote.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(rechercheNote.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                rechercheNote dialog = new rechercheNote();
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton Cancel;
    private javax.swing.JButton cancel;
    private javax.swing.JButton complete;
    private com.toedter.calendar.JDateChooser date;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField note;
    private javax.swing.JButton recherche;
    private javax.swing.JTextArea resultat;
    // End of variables declaration//GEN-END:variables
}
